
#include <cstdlib>
#include <iostream>
#include <cmath>
#include <fstream>

using namespace std;

//----------------------------------------------------------------------------

class Point_2D
{
public:

  // functions

  Point_2D() { }
  Point_2D(int, int);

  friend const Point_2D operator +(Point_2D, Point_2D);
  friend const Point_2D operator -(Point_2D, Point_2D);
  friend const Point_2D operator -(Point_2D);
  friend const Point_2D operator *(Point_2D, int);
  friend const Point_2D operator *(int, Point_2D);
  friend ostream & operator <<(ostream &, Point_2D);
  
  // variables

private:

  int x, y;

};


//----------------------------------------------------------------------------

Point_2D::Point_2D(int xval, int yval)
{
  x = xval;
  y = yval;
}

//----------------------------------------------------------------------------
//----------------------------------------------------------------------------

ostream & operator <<(ostream &outputStream, Point_2D p)
{
  cout << "x = " << p.x << ", y = " << p.y;
  
  return outputStream;
}

//----------------------------------------------------------------------------

const Point_2D operator +(Point_2D p1, Point_2D p2)
{
  return Point_2D(p1.x + p2.x, p1.y + p2.y);
}

//----------------------------------------------------------------------------

const Point_2D operator *(Point_2D p, int val)
{
  return Point_2D(p.x * val, p.y * val);
}

//----------------------------------------------------------------------------

const Point_2D operator *(int val, Point_2D p)
{
  return Point_2D(p.x * val, p.y * val);
}

//----------------------------------------------------------------------------

const Point_2D operator -(Point_2D p1, Point_2D p2)
{
  return Point_2D(p1.x - p2.x, p1.y - p2.y);
}

//----------------------------------------------------------------------------

const Point_2D operator -(Point_2D p)
{
  return Point_2D(-p.x, -p.y);
}

//----------------------------------------------------------------------------
//----------------------------------------------------------------------------

int main()
{
  Point_2D p1, p2, p3;

  p1 = Point_2D(3, 5);
  p2 = Point_2D(6, 1);
  p3 = p1 + 5 * p2;
  //p3 = -p1;


  cout << p3 << endl;


  return 1;
}

//----------------------------------------------------------------------------
//----------------------------------------------------------------------------



